#include <stdio.h>

//funkcija koja mijenja vrijednosti ulaznim parametrima
//funkciji se predavaju adrese varijabli iz glavnog programa
//tako da se u ulazne parametre koji su definirani pokazivaima x i y
//spreamju adrese variajbli a i b iz glavnog programa
//radi toga su promjene u funkciji vidljive i u glavnom programu
void zamjena(int *x, int *y){
    //deklaracija pomone varijable
    int pom;
    //pridruivanje vrijednosti varijable x pomonoj varijabli pom
    //pridruivanje vrijednosti varijable y varijabli x
    //pridruivanje vrijednosti pomone varijable pom varijabli y
    pom = *x;
    *x = *y;
    *y = pom;

}

//funkcija za ispis elemenata polja
void ispis(int *polje, int brel){
	int i;
	for(i=0; i<brel; i++)
	   //moglo se pisati i printf("%d ", polje[i]);
		printf("%d ", *(polje+i));
	printf("\n");
}

//funkcija za mjehuriasto sortiranje (bubble sort)
void bubble_sort(int *polje, int brel){
	int i, j;
	//prva for petlja odreiva redni broj prolaska
	for(i=0; i < brel-1; i++){
		printf("%d. prolaz\n", i+1);
		//u drugoj for petlji se ispisuje polje i usporeivaju elementi
		for(j=0; j < brel-1; j++){
            ispis(polje, brel);
            //gleda se je li sljedei elemenat manji od trenutnog elementa
            //moglo se pisati i if (polje[j+1] < polje[j]) {
			if(*(polje + j + 1) < *(polje + j)){
                //ako jest poziva se funkcija za zamjenu 
                //moglo se pisati i zamjena(&polje[j], &polje[j+1]);
				zamjena(polje + j, polje + j + 1);
			}
		}
	}
}

int main(){
	int i, n;
	//deklaracija polja koje moe sadravati najvie 50 cijelih brojeva
	int polje[50];
	//unos stvarnog broja elemenata polja kojeg elimo sortirati
	printf("Unesite broj elemenata polja kojeg zelite sortirati: ");
	scanf("%d", &n);
	//unos elemenata polja
	printf("Unesite polje cijelih brojeva: ");
	for(i=0; i<n; i++)
		scanf("%d", &polje[i]);
	printf("\n");

	//poziv funkcije za sortiranje
	bubble_sort(polje, n);
	printf("Sortirano polje: ");
	ispis(polje, n);

    system("pause");
	return 0;
}
